
#include <stdio.h>
#include <string.h>


double
srtfmt2seconds (char *input)
{
  int hh, mm, ss, ms;
  double result;

  if (strlen (input) < 10)
    return -1;

  if (strstr (input, ",") == NULL)
    return -2;

  hh = str2int (substr (input, 1, 2));
  mm = str2int (substr (input, 4, 2));
  ss = str2int (substr (input, 7, 2));
  ms = str2mili (strstr (input, ",") + 1);

  result = hh * 60 * 60 + mm * 60 + ss + ms / 1000.;

  return result;
}


char *
seconds2srtfmt (double seconds)
{
  int hh, mm, ss;
  double ms;
  char *retstr = (char *) malloc (16 * sizeof (char));
  long ls;

  hh = seconds / 3600;
  mm = (seconds - hh * 3600.) / 60;
  ss = seconds - hh * 3600. - mm * 60.;
  ms = seconds - (long long) seconds;
  ms *= 1000;

  sprintf (retstr, "%02d:%02d:%02d,%03.0f", hh, mm, ss, ms);

  return retstr;
}


double
subfmt2seconds (char *input)
{
  int hh, mm, ss, ms;
  double result;

  if (strlen (input) < 10)
    return -1;

  if (strstr (input, ".") == NULL)
    return -2;

  hh = str2int (substr (input, 1, 2));
  mm = str2int (substr (input, 4, 2));
  ss = str2int (substr (input, 7, 2));
  ms = str2mili (strstr (input, ".") + 1);

  result = hh * 60 * 60 + mm * 60 + ss + ms / 1000.;

  return result;
}


char *
seconds2subfmt (double seconds)
{
  int hh, mm, ss;
  double ms;
  char *retstr = (char *) malloc (16 * sizeof (char));
  long ls;

  hh = seconds / 3600;
  mm = (seconds - hh * 3600.) / 60;
  ss = seconds - hh * 3600. - mm * 60.;
  ms = seconds - (long long) seconds;
  ms *= 100;

  sprintf (retstr, "%02d:%02d:%02d.%02.0f", hh, mm, ss, ms);

  return retstr;
}
