#include <stdio.h>
#include <string.h>


char
is_txt (char *line)
{
  if (!strncmp ((char *) removeblanks (number2blanks (line)), "{}{}", 4))
    return 1;
  else
    return 0;
}


char
is_sub (char *line)
{
  if (!strcmp
      ((char *) number2blanks (substr (line, 1, 23)),
       "  :  :  .  ,  :  :  .  "))
    return 1;
  else
    return 0;
}


char
is_srt (char *line)
{
  if (strstr ((char *) number2blanks (line), "  :  :  ,    -->   :  :  ,   "))
    return 1;
  else
    return 0;
}


char
sub_detect_type (char *subfile)
{
  FILE *fp;
  char *line, result;
  unsigned long txtcnt, subcnt, srtcnt;

  if ((fp = fopen (subfile, "rb")) == NULL)
    {
      perror (subfile);
      exit (-2);
    }

  txtcnt = srtcnt = subcnt = result = 0;

  while (!feof (fp))
    {
      line = (char *) trimcrlf (fgetline (fp));
      if (!feof (fp))
	{
	  if (is_txt (line))
	    txtcnt++;
	  if (is_sub (line))
	    subcnt++;
	  if (is_srt (line))
	    srtcnt++;
	}
      free (line);
    }
  fclose (fp);

  // printf ("txt: %d   sub: %d srt: %d\n", txtcnt, subcnt, srtcnt);

  if ((txtcnt > 0) && (srtcnt == 0) && (subcnt == 0))
    result = 1;
  else if ((txtcnt == 0) && (srtcnt > 0) && (subcnt == 0))
    result = 2;
  else if ((txtcnt == 0) && (srtcnt == 0) && (subcnt > 0))
    result = 3;
  else
    result = 0;

  return result;

}
